lparameters tcSource, ;
	tcDestination, ;
	tcAction, ;
	tlUserCanceled
local lcLibrary, ;
	loHeap, ;
	lcAction, ;
	laActionList[1], ;
	lnAction, ;
	lcSourceString, ;
	lcDestString, ;
	lnStringBase, ;
	lnFlag, ;
	lcFileOpStruct, ;
	lnRetCode
 
#define ccNULL						chr(0)

#define FO_MOVE						0x0001
#define FO_COPY						0x0002
#define FO_DELETE					0x0003
#define FO_RENAME					0x0004
 
#define FOF_MULTIDESTFILES			0x0001
#define FOF_CONFIRMMOUSE			0x0002
#define FOF_SILENT					0x0004	&& don't create progress/report
#define FOF_RENAMEONCOLLISION		0x0008
#define FOF_NOCONFIRMATION			0x0010	&& don't prompt the user.
#define FOF_WANTMAPPINGHANDLE		0x0020	&& fill in SHFILEOPSTRUCT.hNameMappings
											&& must be freed using SHFreeNameMappings
#define FOF_ALLOWUNDO				0x0040	&& DELETE - sends the file to the Recycle Bin
#define FOF_FILESONLY				0x0080	&& on *.*, do only files
#define FOF_SIMPLEPROGRESS			0x0100	&& means don't show names of files
#define FOF_NOCONFIRMMKDIR			0x0200	&& don't confirm making any needed dirs
#define FOF_NOERRORUI				0x0400	&& don't put up error UI
#define FOF_NOCOPYSECURITYATTRIBS	0x0800	&& don't copy NT file Security Attributes

* Declare the Windows API function we need and create a Heap object.
 
declare integer SHFileOperation in SHELL32.DLL string @ LPSHFILEOPSTRUCT
lcLibrary = 'ClsHeap.prg'
loHeap    = newobject('Heap', lcLibrary)

* Ensure we have a valid action.

lcAction = upper(iif(empty(tcAction) or vartype(tcAction) <> 'C', 'COPY', ;
	tcAction))
alines(laActionList, 'MOVE,COPY,DELETE,RENAME', ',')
lnAction = ascan(laActionList, lcAction)
if lnAction = 0
	return .NULL.
endif lnAction = 0

* Perform the operation.
 
lcSourceString = tcSource + ccNULL + ccNULL
lcDestString   = tcDestination + ccNULL + ccNULL
lnStringBase   = loHeap.AllocBlob(lcSourceString + lcDestString)
lnFlag         = FOF_NOCONFIRMATION + FOF_NOCONFIRMMKDIR + FOF_NOERRORUI
lcFileOpStruct = loHeap.NumToLong(_screen.hWnd) + ;
	loHeap.NumToLong(lnAction) + ;
	loHeap.NumToLong(lnStringBase) + ;
	loHeap.NumToLong(lnStringBase + len(lcSourceString)) + ;
	loHeap.NumToLong(lnFlag) + ;
	loHeap.NumToLong(0) + loHeap.NumToLong(0) + loHeap.NumToLong(0)
lnRetCode = SHFileOperation(@lcFileOpStruct) 

* Flag if the user cancel the operation and return success or failure.

tlUserCanceled = substr(lcFileOpStruct, 19, 4) <> loHeap.NumToLong(0)
return lnRetCode = 0
