* Locale constants used by GetLocaleInfo (adapted from http://www.pinvoke.net/default.aspx/kernel32/GetLocaleInfoEx.html):

#define LOCALE_RETURN_GENITIVE_NAMES		0x10000000
	&& Flag to return the Genitive forms of month names

#define LOCALE_SLOCALIZEDDISPLAYNAME		0x00000002
	&& Localized name of locale, eg "German (Germany)" in UI language
#define LOCALE_SENGLISHDISPLAYNAME			0x00000072
	&& Display name (language + country usually) in English, eg "German (Germany)"
#define LOCALE_SNATIVEDISPLAYNAME			0x00000073
	&& Display name in native locale language, eg "Deutsch (Deutschland)

#define LOCALE_SLOCALIZEDLANGUAGENAME		0x0000006F
	&& Language Display Name for a language, eg "German" in UI language
#define LOCALE_SENGLISHLANGUAGENAME			0x00001001
	&& English name of language, eg "German"
#define LOCALE_SNATIVELANGUAGENAME			0x00000004
	&& Native name of language, eg "Deutsch"

#define LOCALE_SLOCALIZEDCOUNTRYNAME		0x00000006
	&& Localized name of country, eg "Germany" in UI language
#define LOCALE_SENGLISHCOUNTRYNAME			0x00001002
	&& English name of country, eg "Germany"
#define LOCALE_SNATIVECOUNTRYNAME			0x00000008
	&& Native name of country, eg "Deutschland"

#define LOCALE_SABBREVLANGNAME				0x00000003
	&& Abbreviated language name

#define LOCALE_ICOUNTRY						0x00000005
	&& Country code
#define LOCALE_SABBREVCTRYNAME				0x00000007
	&& Abbreviated country name
#define LOCALE_IGEOID						0x0000005B
	&& Geographical location id

#define LOCALE_IDEFAULTLANGUAGE				0x00000009
	&& Default language id
#define LOCALE_IDEFAULTCOUNTRY				0x0000000A
	&& Default country code
#define LOCALE_IDEFAULTCODEPAGE				0x0000000B
	&& Default OEM code page
#define LOCALE_IDEFAULTANSICODEPAGE			0x00001004
	&& Default ANSI code page
#define LOCALE_IDEFAULTMACCODEPAGE			0x00001011
	&& Default Mac code page

#define LOCALE_SLIST						0x0000000C
	&& List item separator
#define LOCALE_IMEASURE						0x0000000D
	&& 0 = metric, 1 = US

#define LOCALE_SDECIMAL						0x0000000E
	&& Decimal separator
#define LOCALE_STHOUSAND					0x0000000F
	&& Thousand separator
#define LOCALE_SGROUPING					0x00000010
	&& Digit grouping
#define LOCALE_IDIGITS						0x00000011
	&& Number of fractional digits
#define LOCALE_ILZERO						0x00000012
	&& Leading zeros for decimal
#define LOCALE_INEGNUMBER					0x00001010
	&& Negative number mode
#define LOCALE_SNATIVEDIGITS				0x00000013
	&& Native digits for 0-9

#define LOCALE_SCURRENCY					0x00000014
	&& Local monetary symbol
#define LOCALE_SINTLSYMBOL					0x00000015
	&& uintl monetary symbol
#define LOCALE_SMONDECIMALSEP				0x00000016
	&& Monetary decimal separator
#define LOCALE_SMONTHOUSANDSEP				0x00000017
	&& Monetary thousand separator
#define LOCALE_SMONGROUPING					0x00000018
	&& Monetary grouping
#define LOCALE_ICURRDIGITS					0x00000019
	&& # local monetary digits
#define LOCALE_IINTLCURRDIGITS				0x0000001A
	&& # uintl monetary digits
#define LOCALE_ICURRENCY					0x0000001B
	&& Positive currency mode
#define LOCALE_INEGCURR						0x0000001C
	&& Negative currency mode

#define LOCALE_SDATE						0x0000001D
	&& Date separator (derived from LOCALE_SSHORTDATE, use that instead)
#define LOCALE_STIME						0x0000001E
	&& Time separator (derived from LOCALE_STIMEFORMAT, use that instead)
#define LOCALE_SSHORTDATE					0x0000001F
	&& Short date format string
#define LOCALE_SLONGDATE					0x00000020
	&& Long date format string
#define LOCALE_STIMEFORMAT					0x00001003
	&& Time format string
#define LOCALE_IDATE						0x00000021
	&& Short date format ordering (derived from LOCALE_SSHORTDATE, use that instead)
#define LOCALE_ILDATE						0x00000022
	&& Long date format ordering (derived from LOCALE_SLONGDATE, use that instead)
#define LOCALE_ITIME						0x00000023
	&& Time format specifier (derived from LOCALE_STIMEFORMAT, use that instead)
#define LOCALE_ITIMEMARKPOSN				0x00001005
	&& Time marker position (derived from LOCALE_STIMEFORMAT, use that instead)
#define LOCALE_ICENTURY						0x00000024
	&& Century format specifier (short date, LOCALE_SSHORTDATE is preferred)
#define LOCALE_ITLZERO						0x00000025
	&& Leading zeros in time field (derived from LOCALE_STIMEFORMAT, use that instead)
#define LOCALE_IDAYLZERO					0x00000026
	&& Leading zeros in day field (short date, LOCALE_SSHORTDATE is preferred)
#define LOCALE_IMONLZERO					0x00000027
	&& Leading zeros in month field (short date, LOCALE_SSHORTDATE is preferred)
#define LOCALE_S1159						0x00000028
	&& AM designator
#define LOCALE_S2359						0x00000029
	&& PM designator

#define LOCALE_ICALENDARTYPE				0x00001009
	&& Type of calendar specifier
#define LOCALE_IOPTIONALCALENDAR			0x0000100B
	&& Additional calendar types specifier
#define LOCALE_IFIRSTDAYOFWEEK				0x0000100C
	&& First day of week specifier
#define LOCALE_IFIRSTWEEKOFYEAR				0x0000100D
	&& First week of year specifier

#define LOCALE_SDAYNAME1					0x0000002A
	&& Long name for Monday
#define LOCALE_SDAYNAME2					0x0000002B
	&& Long name for Tuesday
#define LOCALE_SDAYNAME3					0x0000002C
	&& Long name for Wednesday
#define LOCALE_SDAYNAME4					0x0000002D
	&& Long name for Thursday
#define LOCALE_SDAYNAME5					0x0000002E
	&& Long name for Friday
#define LOCALE_SDAYNAME6					0x0000002F
	&& Long name for Saturday
#define LOCALE_SDAYNAME7					0x00000030
	&& Long name for Sunday
#define LOCALE_SABBREVDAYNAME1				0x00000031
	&& Abbreviated name for Monday
#define LOCALE_SABBREVDAYNAME2				0x00000032
	&& Abbreviated name for Tuesday
#define LOCALE_SABBREVDAYNAME3				0x00000033
	&& Abbreviated name for Wednesday
#define LOCALE_SABBREVDAYNAME4				0x00000034
	&& Abbreviated name for Thursday
#define LOCALE_SABBREVDAYNAME5				0x00000035
	&& Abbreviated name for Friday
#define LOCALE_SABBREVDAYNAME6				0x00000036
	&& Abbreviated name for Saturday
#define LOCALE_SABBREVDAYNAME7				0x00000037
	&& Abbreviated name for Sunday
#define LOCALE_SMONTHNAME1					0x00000038
	&& Long name for January
#define LOCALE_SMONTHNAME2					0x00000039
	&& Long name for February
#define LOCALE_SMONTHNAME3					0x0000003A
	&& Long name for March
#define LOCALE_SMONTHNAME4					0x0000003B
	&& Long name for April
#define LOCALE_SMONTHNAME5					0x0000003C
	&& Long name for May
#define LOCALE_SMONTHNAME6					0x0000003D
	&& Long name for June
#define LOCALE_SMONTHNAME7					0x0000003E
	&& Long name for July
#define LOCALE_SMONTHNAME8					0x0000003F
	&& Long name for August
#define LOCALE_SMONTHNAME9					0x00000040
	&& Long name for September
#define LOCALE_SMONTHNAME10					0x00000041
	&& Long name for October
#define LOCALE_SMONTHNAME11					0x00000042
	&& Long name for November
#define LOCALE_SMONTHNAME12					0x00000043
	&& Long name for December
#define LOCALE_SMONTHNAME13					0x0000100E
	&& Long name for 13th month (if exists)
#define LOCALE_SABBREVMONTHNAME1			0x00000044
	&& Abbreviated name for January
#define LOCALE_SABBREVMONTHNAME2			0x00000045
	&& Abbreviated name for February
#define LOCALE_SABBREVMONTHNAME3			0x00000046
	&& Abbreviated name for March
#define LOCALE_SABBREVMONTHNAME4			0x00000047
	&& Abbreviated name for April
#define LOCALE_SABBREVMONTHNAME5			0x00000048
	&& Abbreviated name for May
#define LOCALE_SABBREVMONTHNAME6			0x00000049
	&& Abbreviated name for June
#define LOCALE_SABBREVMONTHNAME7			0x0000004A
	&& Abbreviated name for July
#define LOCALE_SABBREVMONTHNAME8			0x0000004B
	&& Abbreviated name for August
#define LOCALE_SABBREVMONTHNAME9			0x0000004C
	&& Abbreviated name for September
#define LOCALE_SABBREVMONTHNAME10			0x0000004D
	&& Abbreviated name for October
#define LOCALE_SABBREVMONTHNAME11			0x0000004E
	&& Abbreviated name for November
#define LOCALE_SABBREVMONTHNAME12			0x0000004F
	&& Abbreviated name for December
#define LOCALE_SABBREVMONTHNAME13			0x0000100F
	&& Abbreviated name for 13th month (if exists)

#define LOCALE_SPOSITIVESIGN				0x00000050
	&& Positive sign
#define LOCALE_SNEGATIVESIGN				0x00000051
	&& Negative sign
#define LOCALE_IPOSSIGNPOSN					0x00000052
	&& Positive sign position (derived from INEGCURR)
#define LOCALE_INEGSIGNPOSN					0x00000053
	&& Negative sign position (derived from INEGCURR)
#define LOCALE_IPOSSYMPRECEDES				0x00000054
	&& Mon sym precedes pos amt (derived from ICURRENCY)
#define LOCALE_IPOSSEPBYSPACE				0x00000055
	&& Mon sym sep by space from pos amt (derived from ICURRENCY)
#define LOCALE_INEGSYMPRECEDES				0x00000056
	&& Mon sym precedes neg amt (derived from INEGCURR)
#define LOCALE_INEGSEPBYSPACE				0x00000057
	&& Mon sym sep by space from neg amt (derived from INEGCURR)

#define LOCALE_FONTSIGNATURE				0x00000058
	&& Font signature
#define LOCALE_SISO639LANGNAME				0x00000059
	&& ISO abbreviated language name
#define LOCALE_SISO3166CTRYNAME				0x0000005A
	&& ISO abbreviated country name

#define LOCALE_IDEFAULTEBCDICCODEPAGE		0x00001012
	&& Default EBCDIC code page
#define LOCALE_IPAPERSIZE					0x0000100A
	&& 1 = letter, 5 = legal, 8 = a3, 9 = a4
#define LOCALE_SENGCURRNAME					0x00001007
	&& English name of currency
#define LOCALE_SNATIVECURRNAME				0x00001008
	&& Native name of currency
#define LOCALE_SYEARMONTH					0x00001006
	&& Year month format string
#define LOCALE_SSORTNAME					0x00001013
	&& Sort name
#define LOCALE_IDIGITSUBSTITUTION			0x00001014
	&& 0 = context, 1 = none, 2 = national

#define LOCALE_SNAME						0x0000005C
	&& Locale name (with sort info) (ie: de-DE_phoneb)
#define LOCALE_SDURATION					0x0000005D
	&& Time duration format
#define LOCALE_SKEYBOARDSTOINSTALL			0x0000005E
	&& (Windows only) keyboards to install
#define LOCALE_SSHORTESTDAYNAME1			0x00000060
	&& Shortest day name for Monday
#define LOCALE_SSHORTESTDAYNAME2			0x00000061
	&& Shortest day name for Tuesday
#define LOCALE_SSHORTESTDAYNAME3			0x00000062
	&& Shortest day name for Wednesday
#define LOCALE_SSHORTESTDAYNAME4			0x00000063
	&& Shortest day name for Thursday
#define LOCALE_SSHORTESTDAYNAME5			0x00000064
	&& Shortest day name for Friday
#define LOCALE_SSHORTESTDAYNAME6			0x00000065
	&& Shortest day name for Saturday
#define LOCALE_SSHORTESTDAYNAME7			0x00000066
	&& Shortest day name for Sunday
#define LOCALE_SISO639LANGNAME2				0x00000067
	&& 3 character ISO abbreviated language name
#define LOCALE_SISO3166CTRYNAME2			0x00000068
	&& 3 character ISO country name
#define LOCALE_SNAN							0x00000069
	&& Not a Number
#define LOCALE_SPOSINFINITY					0x0000006A
	&& + Infinity
#define LOCALE_SNEGINFINITY					0x0000006B
	&& - Infinity
#define LOCALE_SSCRIPTS						0x0000006C
	&& Typical scripts in the locale
#define LOCALE_SPARENT						0x0000006D
	&& Fallback name for resources
#define LOCALE_SCONSOLEFALLBACKNAME			0x0000006E
	&& Fallback name for within the console
