*==============================================================================
* Function:			GetLocaleInfo
* Purpose:			Gets locale settings
* Author:			Doug Hennig
* Copyright:		(c) 2015 Stonefield Systems Group Inc.
* Last Revision:	07/02/2015
* Parameters:		tnSetting - the setting to retrieve (see constants in
*						GetLocaleInfo.H)
*					tcLocale  - the locale in the format <language>-<REGION>,
*						such as en-US (optional: if it isn't passed, the
*						default locale for the user is used)
* Returns:			the desired setting
* Environment in:	none
* Environment out:	none
* Notes:			adapted from http://praisachion.blogspot.ro/2015/06/using-getlocaleinfo-and-getlocaleinfoex.html
*==============================================================================

lparameters tnSetting, ;
	tcLocale
#define ccNULL chr(0)
local lcLocale, ;
	lnLen, ;
	lcBuffer, ;
	lnReturn, ;
	lcReturn
if vartype(tcLocale) = 'C' and not empty(tcLocale)
	lcLocale = strconv(tcLocale, 5) + ccNULL
else
	lcLocale = .NULL.
endif vartype(tcLocale) = 'C' ...
declare integer GetLocaleInfoEx in Win32API ;
	string locale, long type, string @buffer, integer len
lnLen    = 255
lcBuffer = space(lnLen)
lnReturn = GetLocaleInfoEx(lcLocale, tnSetting, @lcBuffer, lnLen)
lcReturn = strconv(left(lcBuffer, 2 * (lnReturn - 1)), 6)
return lcReturn
