*==============================================================================
* Program:			GetNetConnection
* Purpose:			Returns the network name for a mapped device
* Author:			Doug Hennig, adapted from coded posted by Ed Rauh
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last revision:	01/21/2001
* Parameters:		tcDevice - the device name
* Returns:			the network name for the device if it was mapped or an
*						empty string if not
* Environment in:	the specified device must exist
* Environment out:	none
*==============================================================================

lparameters tcDevice
local lcName, ;
	lnLength, ;
	lcBuffer

* If the path wasn't specified, use the current drive.

if vartype(tcDevice) <> 'C' or empty(tcDevice)
	lcName = sys(5)
else
	lcName = tcDevice
endif vartype(tcDevice) <> 'C' ...

* Set up the buffer and declare the WinAPI function we'll need.

lnLength = 261
lcBuffer = replicate(chr(0), lnLength)
declare integer WNetGetConnection in Win32API ;
	string lpLocalName, string @lpRemoteName, integer @lpnLength

* Call the API function and return the result.

if WNetGetConnection(lcName, @lcBuffer, @lnLength) = 0
	lcReturn = left(lcBuffer, at(chr(0), lcBuffer) - 1)
else
	lcReturn = ''
endif WNetGetConnection(lcName, ...
return lcReturn
