lparameters tcVolume, ;
	taArray
local lcVolume, ;
	lcVolumeName, ;
	lnVolumeNameLen, ;
	lnVolumeSerialNumber, ;
	lnMaxFileNameLen, ;
	lnFileSystemFlags, ;
	lcFileSystemName, ;
	lnFileSystemNameLen, ;
	lcFileInfo, ;
	lcFileName, ;
	laFiles[1], ;
	lnFiles, ;
	lnI, ;
	lcFile, ;
	lnHandle

* Declare the API function and constants.

declare GetVolumeInformation in Win32API ;
	string lpRootPathName, string @lpVolumeNameBuffer, ;
	integer nVolumeNameSize, integer @lpVolumeSerialNumber, ;
	integer @lpMaxFileNameLength, integer @lpFileSystemFlags, ;
	string @lpFileSystemNameBuffer, integer nFileSystemNameSize
#define cnFS_CASE_SENSITIVE          0
#define cnFS_CASE_IS_PRESERVED       1
#define cnFS_UNICODE_STORED_ON_DISK  2
#define cnFS_PERSISTENT_ACLS         3
#define cnFS_FILE_COMPRESSION        4
#define cnFS_VOL_IS_COMPRESSED      15

* If the path wasn't specified, use the current drive. Otherwise, get the drive
* for the specified path, handling UNC paths specially.

do case
	case vartype(tcVolume) <> 'C' or empty(tcVolume)
		lcVolume = addbs(sys(5))
	case left(tcVolume, 2) = '\\'
		lcVolume = addbs(tcVolume)
		lcVolume = left(lcVolume, at('\', lcVolume, 4))
	case len(tcVolume) = 1
		lcVolume = tcVolume + ':\'
	otherwise
		lcVolume = addbs(justdrive(tcVolume))
endcase

* Create the parameters for the API function, then call it.

lcVolumeName         = space(255)
lnVolumeNameLen      = len(lcVolumeName)
lnVolumeSerialNumber = 0
lnMaxFileNameLen     = 0
lnFileSystemFlags    = 0
lcFileSystemName     = space(255)
lnFileSystemNameLen  = len(lcFileSystemName)
GetVolumeInformation(lcVolume, @lcVolumeName, lnVolumeNameLen, ;
	@lnVolumeSerialNumber, @lnMaxFileNameLen, @lnFileSystemFlags, ;
	@lcFileSystemName, lnFileSystemNameLen)

* Put the information into the array.

dimension taArray[10]
taArray[ 1] = left(lcVolumeName, at(chr(0), lcVolumeName) - 1)
taArray[ 2] = lnVolumeSerialNumber
taArray[ 3] = left(lcFileSystemName, at(chr(0), lcFileSystemName) - 1)
taArray[ 4] = bittest(lnFileSystemFlags, cnFS_CASE_SENSITIVE)
taArray[ 5] = bittest(lnFileSystemFlags, cnFS_CASE_IS_PRESERVED)
taArray[ 6] = bittest(lnFileSystemFlags, cnFS_UNICODE_STORED_ON_DISK)
taArray[ 7] = bittest(lnFileSystemFlags, cnFS_PERSISTENT_ACLS)
taArray[ 8] = bittest(lnFileSystemFlags, cnFS_FILE_COMPRESSION)
taArray[ 9] = bittest(lnFileSystemFlags, cnFS_VOL_IS_COMPRESSED)
taArray[10] = lnMaxFileNameLen
return .T.
