*==============================================================================
* Method:			Hex2Decimal
* Status:			Protected
* Purpose:			Converts a value in Intel format to a decimal value
* Author:			Doug Hennig
* Copyright:		(c) 1996-2003 Stonefield Systems Group Inc.
* Last Revision:	09/03/2003
* Parameters:		tcValue  - the value to convert
*					tlSigned - .T. if the value is signed
* Returns:			the numeric value
* Environment in:	none
* Environment out:	none
*==============================================================================

lparameters tcValue, ;
	tlSigned
local lnDecimal, ;
	lnLen, ;
	lnI, ;
	lnMSB, ;
	lnMax
lnDecimal = 0
lnLen     = len(tcValue)
for lnI = 1 to lnLen
	lnDecimal = lnDecimal + asc(substr(tcValue, lnI, 1)) * 256 ^ (lnI - 1)
next lnI
if tlSigned
	lnMSB = (lnLen * 8) - 1
	if bittest(lnDecimal, lnMSB)
		lnMax     = 2 ^ (lnMSB + 1)
		lnDecimal = lnDecimal - lnMax
	endif bittest(lnDecimal, lnMSB)
endif tlSigned
return lnDecimal
