* Detects if the program is already running.
* Note: be sure to pass tcWindowName if the application is a top-level form.

lparameters tcWindowName, ;
	tlExactName
local llIsAppRunning, ;
	lcWindowName, ;
	lnFoxHWnd, ;
	lnHWndNext, ;
	lnBuffer, ;
	lcBuffer, ;
	lcOurClass, ;
	lcClass

* Define some constants and WinAPI functions.

#define GW_OWNER 4
#define GW_HWNDFIRST 0
#define GW_HWNDNEXT 2
#define SW_SHOWNORMAL 1
declare integer SetForegroundWindow in Win32API ;
	integer lnhWnd
declare integer GetWindowText in Win32API ;
	integer lnhWnd, string lpString, integer cCH
declare integer GetWindow in Win32API ;
	integer lnhWnd, integer wCmd
declare integer GetActiveWindow in Win32API
declare integer GetClassName in Win32API ;
	integer lnhWnd, string @lpClassName, integer lnMaxCount
declare integer ShowWindow in Win32API ;
	integer lnhWnd, integer lnCmdShow

* If a window name wasn't passed, use _screen.Caption.

lcWindowName = iif(vartype(tcWindowName) = 'C' and not empty(tcWindowName), ;
	tcWindowName, _screen.Caption) 
lnFoxHWnd  = GetActiveWindow()
lnHWndNext = GetWindow(lnFoxHWnd, GW_HWNDFIRST)

* Get our window class name.

lnBuffer   = 200
lcBuffer   = space(lnBuffer)
lnBuffer   = GetClassName(lnFoxHWnd, @lcBuffer, lnBuffer)
lcOurClass = left(lcBuffer, lnBuffer - 1)

* Check each window for the specified title. Skip this application's window and
* any child windows. If we find one, bring it to the front.

do while lnHWndNext <> 0
	if lnHWndNext <> lnFoxHWnd and GetWindow(lnHWndNext, GW_OWNER) = 0
		lcTitle = space(64)
		GetWindowText(lnHWndNext, @lcTitle, 64)
		if (lcWindowName $ lcTitle and not tlExactName) or ;
			(lcWindowName == lcTitle and tlExactName)
			lnBuffer = 200
			lcBuffer = space(lnBuffer)
			lnBuffer = GetClassName(lnHWndNext, @lcBuffer, lnBuffer)
			lcClass  = left(lcBuffer, lnBuffer - 1)
			if lcClass == lcOurClass
				llIsAppRunning = .T.
				SetForegroundWindow(lnHWndNext)
				ShowWindow(lnHWndNext, SW_SHOWNORMAL)
				exit
			endif lcClass == lcOurClass
		endif (lcWindowName $ lcTitle ...
	endif lnHWndNext <> lnFoxHWnd ...
	lnHWndNext = GetWindow(lnHWndNext, GW_HWNDNEXT)
enddo while lnHWndNext <> 0
return llIsAppRunning
