lparameters tcCaption
local lnhWnd, ;
	llReturn, ;
	lnProcessID, ;
	lnHandle

* Declare the Win32API functions we need.

#define WM_DESTROY 0x0002
declare integer FindWindow in Win32API ;
	string @cClassName, string @cWindowName
declare integer SendMessage in Win32API ;
	integer hWnd, integer uMsg, integer wParam, integer lParam
declare Sleep in Win32API ;
	integer nMilliseconds
declare integer GetWindowThreadProcessId in Win32API ;
	integer hWnd, integer @lpdwProcessId
declare integer OpenProcess in Win32API ;
	integer dwDesiredAccess, integer bInheritHandle, integer dwProcessID
declare integer TerminateProcess in Win32API ;
	integer hProcess, integer uExitCode

* Get a handle to the window by its caption.

lnhWnd   = FindWindow(0, tcCaption)
llReturn = lnhWnd = 0

* If we found the window, send a "destroy" message to it, then wait for it to
* be gone. If it didn't, let's use the big hammer: we'll terminate its process.

if not llReturn
	SendMessage(lnhWnd, WM_DESTROY, 0, 0)
	llReturn = WaitForAppTermination(tcCaption)
	if not llReturn
		lnProcessID = 0
		GetWindowThreadProcessId(lnhWnd, @lnProcessID)
		lnHandle = OpenProcess(1, 1, lnProcessID)
		llReturn = TerminateProcess(lnHandle, 0) > 0
	endif not llReturn
endif not llReturn
return llReturn

* For up to five times, wait for a second, then see if the specified application
* is still running. Return .T. if the application has terminated.

function WaitForAppTermination
lparameters tcCaption
local lnCounter, ;
	llReturn
lnCounter = 0
llReturn  = .F.
do while not llReturn and lnCounter < 5
	Sleep(1000)
	lnCounter = lnCounter + 1
	llReturn  = FindWindow(0, tcCaption) = 0
enddo while not llReturn ...
return llReturn
