*==============================================================================
* Program:			LockWindow
* Purpose:			Locks Windows from updating a window
* Author:			Doug Hennig
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last Revision:	02/08/2001
* Parameters:		tlLock - .T. to lock the window, .F. to unlock
*					tnHWnd - the handle of the window (optional: if it isn't
*						passed, the active window is used)
* Returns:			.T.
* Environment in:	none
* Environment out:	the window is either locked or unlocked, depending on
*						tlLock
*==============================================================================

lparameters tlLock, ;
	tnHWnd
local lnHWnd
declare integer LockWindowUpdate in Win32API ;
	integer nHandle
do case
	case not tlLock
		lnHWnd = 0
	case pcount() = 1
		declare integer GetDesktopWindow in Win32API
		lnHWnd = GetDesktopWindow()
	otherwise
		lnHWnd = tnHWnd
endcase
LockWindowUpdate(lnHWnd)
return
