lparameters tcFileName, ;
	ttCreated, ;
	ttAccessed, ;
	ttModified
local lnFile, ;
	lcCreated, ;
	lcAccessed, ;
	lcModified, ;
	lnResult

* Declare the Windows API functions we need.

declare integer CloseHandle in Kernel32.dll ;
	integer HANDLE_hObject
declare integer CreateFile in Kernel32.dll as apiCreateFile ;
	string @ LPCTSTR_lpFileName, ;
	long DWORD_dwDesiredAccess, ;
	long DWORD_dwShareMode, ;
	string @ LPSECURITY_ATTRIBUTES_lpSecurityAttributes, ;
	long DWORD_dwCreationDisposition, ;
	long DWORD_dwFlagsAndAttributes, ;
	integer HANDLE_hTemplateFile
declare integer SetFileTime in Kernel32.dll ;
	long HANDLE_hFile, ;
	string @ const_FILETIME_ptr_lpCreationTime,   ;
	string @ const_FILETIME_ptr_lpLastAccessTime,  ;
	string @ const_FILETIME_ptr_lpLastWriteTime
declare integer SystemTimeToFileTime in Kernel32.dll ;
	string @lpSystemTime, string @lpFileTime
declare integer LocalFileTimeToFileTime in Kernel32.dll ;
	string @lpLocalTime, string @lpFileTime

* Define some constants.

#define GENERIC_READ				0x80000000
#define FILE_WRITE_ATTRIBUTES		0x0100
#define FILE_SHARE_READ				0x00000001
#define FILE_SHARE_DELETE			0x00000004
#define OPEN_EXISTING				3
#define FILE_FLAG_BACKUP_SEMANTICS	0x02000000

* Open the file. If we can't, return .F.

lnFile = apiCreateFile(tcFileName, bitor(GENERIC_READ, FILE_WRITE_ATTRIBUTES), ;
	bitor(FILE_SHARE_READ, FILE_SHARE_DELETE), 0, OPEN_EXISTING, ;
	FILE_FLAG_BACKUP_SEMANTICS, 0)
if lnFile < 0
	return .F.
endif lnFile < 0

* Put the specified dates into structures.

lcCreated  = iif(empty(ttCreated)  or vartype(ttCreated)  <> 'T', .NULL., ;
	GetDateTimeStructure(ttCreated))
lcAccessed = iif(empty(ttAccessed) or vartype(ttAccessed) <> 'T', .NULL., ;
	GetDateTimeStructure(ttAccessed))
lcModified = iif(empty(ttModified) or vartype(ttModified) <> 'T', .NULL., ;
	GetDateTimeStructure(ttModified))

* Set the file datetime and return if we succeeded or not.

lnResult = SetFileTime(lnFile, @lcCreated, @lcAccessed, @lcModified)
CloseHandle(lnFile)
return lnResult <> 0


function GetDateTimeStructure(ttDateTime)
local lcSystemTime, ;
	lcLocalFileTime, ;
	lcFileTime
lcSystemTime = bintoc(year(ttDateTime), '2RS') + ;
	bintoc(month(ttDateTime), '2RS') + ;
	bintoc(dow(ttDateTime, 1) - 1, '2RS') + ;
	bintoc(day(ttDateTime), '2RS') + ;
	bintoc(hour(ttDateTime), '2RS') + ;
	bintoc(minute(ttDateTime), '2RS') + ;
	bintoc(sec(ttDateTime), '2RS') + ;
	bintoc(0, '2RS')
lcLocalFileTime = replicate(chr(0), 8)
lcFileTime      = replicate(chr(0), 8)
SystemTimeToFileTime(lcSystemTime, @lcLocalFileTime)
LocalFileTimeToFileTime(lcLocalFileTime, @lcFileTime)
return lcFileTime
